import { RemoteData, RemoteFailure, RemoteInitial, RemoteSuccess } from './remote-data';
import { Type } from 'io-ts/es6/index';
export declare type JSONRemoteProgress = {
    loaded: number;
    total: number | null;
};
export declare type JSONRemotePending = {
    _tag: 'RemotePending';
    progress: JSONRemoteProgress | null;
};
export declare type JSONRemoteData<E, A> = RemoteFailure<E> | RemoteInitial | JSONRemotePending | RemoteSuccess<A>;
export declare function createRemoteDataFromJSON<LA, LO, RA, RO>(leftCodec: Type<LA, LO>, rightCodec: Type<RA, RO>): Type<RemoteData<LA, RA>, JSONRemoteData<LO, RO>>;
