"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var optionFromNullable_1 = require("io-ts-types/lib/optionFromNullable");
var index_1 = require("io-ts/lib/index");
var RemoteInitialCodec = index_1.type({
    _tag: index_1.literal('RemoteInitial'),
});
var RemoteProgressCodec = index_1.type({
    loaded: index_1.number,
    total: optionFromNullable_1.optionFromNullable(index_1.number),
});
var RemotePendingCodec = index_1.type({
    _tag: index_1.literal('RemotePending'),
    progress: optionFromNullable_1.optionFromNullable(RemoteProgressCodec),
});
function createRemoteDataFromJSON(leftCodec, rightCodec) {
    var RemoteFailureCodec = index_1.type({
        _tag: index_1.literal('RemoteFailure'),
        error: leftCodec,
    });
    var RemoteSuccessCodec = index_1.type({
        _tag: index_1.literal('RemoteSuccess'),
        value: rightCodec,
    });
    return index_1.union([RemoteInitialCodec, RemotePendingCodec, RemoteFailureCodec, RemoteSuccessCodec], '_tag');
}
exports.createRemoteDataFromJSON = createRemoteDataFromJSON;
